/* =============================================================================
 *
 *  Description: This is a C++ to C Thread Header file for Thread Hibernate
 *
 * -----------------------------------------------------------------------------
 *  Comments:
 *
 * ===========================================================================*/

#ifndef _Hibernate_H_
#define _Hibernate_H_

void Configure_RTC(void);

#pragma diag(push)
#pragma diag(suppress: 177,401,451,826,831,1462)

#include "VDK.h"
#pragma diag(pop)

#ifdef __ECC__	/* for C/C++ access */
#ifdef __cplusplus
extern "C" void Hibernate_InitFunction(void**, VDK::Thread::ThreadCreationBlock *);
#else
extern "C" void Hibernate_InitFunction(void**, VDK_ThreadCreationBlock *);
#endif
extern "C" void Hibernate_DestroyFunction(void**);
extern "C" int  Hibernate_ErrorFunction(void**);
extern "C" void Hibernate_RunFunction(void**);
#endif /* __ECC__ */

#ifdef __cplusplus
#include <new>

class Hibernate_Wrapper : public VDK::Thread
{
public:
    Hibernate_Wrapper(VDK::ThreadCreationBlock &t)
        : VDK::Thread(t)
    { Hibernate_InitFunction(&m_DataPtr, &t); }

    ~Hibernate_Wrapper()
    { Hibernate_DestroyFunction(&m_DataPtr); }

    int ErrorHandler()
    { 
      return Hibernate_ErrorFunction(&m_DataPtr);
     }

    void Run()
    { Hibernate_RunFunction(&m_DataPtr); }

    static VDK::Thread* Create(VDK::Thread::ThreadCreationBlock &t)
    { return new (t) Hibernate_Wrapper(t); }
};

#endif /* __cplusplus */
#endif /* _Hibernate_H_ */

/* ========================================================================== */
